/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class AngularVelocityParticle3DTracker extends Particle3DTracker
{
	
	JLabel pitchVel, yawVel, rollVel;
	
	public AngularVelocityParticle3DTracker(Particle3D p)
	{
		super();
		particles = new Particle3D[1];
		particles[0] = p;
	 	this.setTitle("Vel: " + p.getName());
	 	
	 	pitchVel = new JLabel("P: " + p.getAngularSpeed().x);
	 	yawVel = new JLabel("Y: " + p.getAngularSpeed().y);
	 	rollVel = new JLabel("R: " + p.getAngularSpeed().z);
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1, 3));
	 	cp.add(pitchVel);
	 	cp.add(yawVel);
	 	cp.add(rollVel);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		this.setTitle("AngVel: " + particles[0].getName());
		pitchVel.setText("P: " + particles[0].getAngularSpeed().x);
	 	yawVel.setText("Y: " + particles[0].getAngularSpeed().y);
	 	rollVel.setText("R: " + particles[0].getAngularSpeed().z);
	 	}
	
	public String toString()
	{
		return "AngVel: " + particles[0].getName() + " : "
				+ "P: " + particles[0].getAngularSpeed().x + " : "
	 			+ "Y: " + particles[0].getAngularSpeed().y + " : "
	 			+ "R: " + particles[0].getAngularSpeed().z;
	}

}