/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class DistanceParticle3DTracker extends Particle3DTracker
{
	
	JLabel distance;
	
	public DistanceParticle3DTracker(Particle3D p1, Particle3D p2)
	{
		super();
		particles = new Particle3D[2];
		particles[0] = p1;
		particles[1] = p2;
	 	this.setTitle("Dist: " + p1.getName() + " to " + p2.getName());
	 	
	 	Vector3d distanceV = (Vector3d)p1.getPosition().clone();
	 	distanceV.sub(p2.getPosition());
	 	
	 	distance = new JLabel("Distance: " + distanceV.length());
	 	
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1, 1));
	 	cp.add(distance);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		this.setTitle("Dist: " + particles[0].getName() + " to " + particles[1].getName());
		Vector3d distanceV = (Vector3d)particles[0].getPosition().clone();
	 	distanceV.sub(particles[1].getPosition());
	 	
	 	distance.setText("Distance: " + formatter.format(distanceV.length()));
	}
	
	public String toString()
	{
		Vector3d distanceV = (Vector3d)particles[0].getPosition().clone();
	 	distanceV.sub(particles[1].getPosition());
		return"Dist: " + particles[0].getName() + " to " + particles[1].getName() + " : " 
				+ "Distance: " + formatter.format(distanceV.length());
	}
	

}