/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class MomentumParticle3DTracker extends Particle3DTracker
{
	
	JLabel xMom, yMom, zMom, mMom;
	
	public MomentumParticle3DTracker(Particle3D p)
	{
		super();
		particles = new Particle3D[1];
		particles[0] = p;
	 	this.setTitle("Mom: " + p.getName());
	 	
	 	Vector3d momentum = p.getMomentum();
	 	
	 	xMom = new JLabel("X: " + momentum.x);
	 	yMom = new JLabel("Y: " + momentum.y);
	 	zMom = new JLabel("Z: " + momentum.z);
	 	mMom = new JLabel("Avg: " + momentum.length());
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1, 4));
	 	cp.add(xMom);
	 	cp.add(yMom);
	 	cp.add(zMom);
	 	cp.add(mMom);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		Vector3d momentum = particles[0].getMomentum();	
		this.setTitle("Mom: " + particles[0].getName());
		xMom.setText("X: " + momentum.x);
	 	yMom.setText("Y: " + momentum.y);
	 	zMom.setText("Z: " + momentum.z);
	 	mMom.setText("Avg: " +  momentum.length());
	}
	
	public String toString()
	{
		Vector3d momentum = particles[0].getMomentum();	
		return "Mom: " + particles[0].getName() + " : "
				+ "X: " + momentum.x + " : "
	 			+ "Y: " + momentum.y + " : "
	 			+ "Z: " + momentum.z;
	}

}