/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class OrientationParticle3DTracker extends Particle3DTracker
{
	
	JLabel pitch, yaw, roll;
	
	public OrientationParticle3DTracker(Particle3D p)
	{
		super();
		particles = new Particle3D[1];
		particles[0] = p;
	 	this.setTitle("Ori: " + p.getName());
	 	
	 	Vector3d orientation = Particle3D.makeEulerAnglesFromQ(p.getOrientation());
	 	
	 	pitch = new JLabel("P: " + orientation.x);
	 	yaw = new JLabel("Y: " + orientation.y);
	 	roll = new JLabel("R: " + orientation.z);
	 	
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1, 3));
	 	cp.add(pitch);
	 	cp.add(yaw);
	 	cp.add(roll);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		this.setTitle("Ori: " + particles[0].getName());
		
		Vector3d orientation = Particle3D.makeEulerAnglesFromQ(particles[0].getOrientation());

		
		pitch.setText("P: " + orientation.x);
	 	yaw.setText("Y: " + orientation.y);
	 	roll.setText("R: " + orientation.z);
	}
	
	public String toString()
	{
		Vector3d orientation = Particle3D.makeEulerAnglesFromQ(particles[0].getOrientation());		
	
		return "Ori: " + particles[0].getName() + " : "
				+ "P: " + orientation.x + " : "
	 			+ "Y: " + orientation.y + " : "
	 			+ "R: " + orientation.z;
	}
	

}