/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class PositionParticle3DTracker extends Particle3DTracker
{
	
	JLabel xPos, yPos, zPos;
	
	public PositionParticle3DTracker(Particle3D p)
	{
		super();
		particles = new Particle3D[1];
		particles[0] = p;
	 	this.setTitle("Pos: " + p.getName());
	 	
	 	xPos = new JLabel("X: " + p.getPosition().x);
	 	yPos = new JLabel("Y: " + p.getPosition().y);
	 	zPos = new JLabel("Z: " + p.getPosition().z);
	 	
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1, 3));
	 	cp.add(xPos);
	 	cp.add(yPos);
	 	cp.add(zPos);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		this.setTitle("Pos: " + particles[0].getName());
		xPos.setText("X: " + particles[0].getPosition().x);
	 	yPos.setText("Y: " + particles[0].getPosition().y);
	 	zPos.setText("Z: " + particles[0].getPosition().z);
	}
	
	public String toString()
	{
		return "Pos: " + particles[0].getName() + " : "
				+ "X: " + particles[0].getPosition().x + " : "
	 			+ "Y: " + particles[0].getPosition().y + " : "
	 			+ "Z: " + particles[0].getPosition().z;
	}
	

}