/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/


package com.bchilds.Physics3D;

import java.awt.*;
import java.awt.event.*;
import	javax.swing.*;

import javax.vecmath.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.image.TextureLoader;
import com.sun.j3d.utils.behaviors.vp.OrbitBehavior;
import com.sun.j3d.utils.picking.*;


public class PropertiesFrame extends JFrame implements WindowStateListener {

//
public static Physics3DFrame mainFrame;
Particle3D currentObject = null;

// IMPORTANT: Source code between BEGIN/END comment pair will be regenerated
// every time the form is saved. All manual changes will be overwritten.
// BEGIN GENERATED CODE
	// member declarations
	JLabel jLabel1 = new JLabel();
	JTextField mass = new JTextField();
	JButton updateButton = new JButton();
	JButton resetButton = new JButton();
	JLabel jLabel10 = new JLabel();
	JTextField radius = new JTextField();
	JPanel jPanel1 = new JPanel();
	JTextField xPosition = new JTextField();
	JTextField yPosition = new JTextField();
	JTextField zPosition = new JTextField();
	JLabel jLabel2 = new JLabel();
	JLabel jLabel3 = new JLabel();
	JLabel jLabel4 = new JLabel();
	JPanel jPanel2 = new JPanel();
	JTextField xSpeed = new JTextField();
	JTextField ySpeed = new JTextField();
	JTextField zSpeed = new JTextField();
	JLabel jLabel7 = new JLabel();
	JLabel jLabel8 = new JLabel();
	JLabel jLabel9 = new JLabel();
	
	JPanel orientationPanel = new JPanel();
	JTextField pitch = new JTextField();
	JTextField yaw = new JTextField();
	JTextField roll = new JTextField();
	JLabel pitchLabel = new JLabel();
	JLabel yawLabel = new JLabel();
	JLabel rollLabel = new JLabel();
	
	JPanel angularVelPanel = new JPanel();
	JTextField pitchVel = new JTextField();
	JTextField yawVel = new JTextField();
	JTextField rollVel = new JTextField();
	JLabel pitchVelLabel = new JLabel();
	JLabel yawVelLabel = new JLabel();
	JLabel rollVelLabel = new JLabel();
	
	JTextField name = new JTextField();
	JTextField elasticity = new JTextField();
	JLabel jLabel5 = new JLabel();
	JLabel jLabel6 = new JLabel();
	JButton prevButton = new JButton();
	JButton nextButton = new JButton();
// END GENERATED CODE

	public PropertiesFrame() {
	}

	public void initComponents() throws Exception {

	
		Image img0 = getToolkit().getImage(ClassLoader.getSystemResource("physics3d.gif"));
	
		jLabel1.setLocation(new Point(16, 487));
		jLabel1.setSize(new Dimension(64, 20));
		jLabel1.setText("Mass (kg)");
		jLabel1.setVisible(true);
		mass.setLocation(new Point(144, 487));
		mass.setSize(new Dimension(50, 20));
		mass.setText("100");
		mass.setVisible(true);
		updateButton.setLocation(new Point(13, 560));
		updateButton.setSize(new Dimension(80, 30));
		updateButton.setText("Update");
		updateButton.setVisible(true);
		resetButton.setLocation(new Point(123, 560));
		resetButton.setSize(new Dimension(70, 30));
		resetButton.setText("Reset");
		resetButton.setVisible(true);
		jLabel10.setLocation(new Point(16, 456));
		jLabel10.setSize(new Dimension(64, 20));
		jLabel10.setText("Radius (m)");
		jLabel10.setVisible(true);
		radius.setLocation(new Point(144, 456));
		radius.setSize(new Dimension(50, 20));
		radius.setText(".1");
		radius.setVisible(true);
		
		jPanel1.setBorder(new javax.swing.plaf.BorderUIResource.TitledBorderUIResource(new javax.swing.border.LineBorder(new Color(153, 153, 153), 1, false), "Position (m)", 4, 2, new Font("Dialog", 1, 12), Color.black));
		jPanel1.setLayout(new BoxLayout(jPanel1, BoxLayout.Y_AXIS));
		jPanel1.setLocation(new Point(9, 49));
		jPanel1.setSize(new Dimension(184, 94));
		jPanel1.setVisible(true);
		
		JPanel p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		jLabel2.setText("X: ");
		xPosition.setText("0.0");
		
		p.add(jLabel2);
		p.add(xPosition);
		
		jPanel1.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
		
		
		jLabel3.setText("Y: ");		
		yPosition.setText("0.0");
		
		p.add(jLabel3);
		p.add(yPosition);
		
		jPanel1.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		jLabel4.setText("Z: ");
		zPosition.setText("0.0");
		
		p.add(jLabel4);
		p.add(zPosition);
		
		jPanel1.add(p);
				

		jPanel2.setBorder(new javax.swing.plaf.BorderUIResource.TitledBorderUIResource(new javax.swing.border.LineBorder(new Color(153, 153, 153), 1, false), "Velocity (m/s)", 4, 2, new Font("Dialog", 1, 12), Color.black));
		jPanel2.setLayout(new BoxLayout(jPanel2, BoxLayout.Y_AXIS));
		jPanel2.setLocation(new Point(9, 150));
		jPanel2.setSize(new Dimension(184, 94));
		jPanel2.setVisible(true);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		jLabel7.setText("X: ");
		xSpeed.setText("0.0");
		
		p.add(jLabel7);
		p.add(xSpeed);
		
		jPanel2.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
		
		
		jLabel8.setText("Y: ");		
		ySpeed.setText("0.0");
		
		p.add(jLabel8);
		p.add(ySpeed);
		
		jPanel2.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		jLabel9.setText("Z: ");
		zSpeed.setText("0.0");
		
		p.add(jLabel9);
		p.add(zSpeed);
		
		jPanel2.add(p);
		

		orientationPanel.setBorder(new javax.swing.plaf.BorderUIResource.TitledBorderUIResource(new javax.swing.border.LineBorder(new Color(153, 153, 153), 1, false), "Orientation (r)", 4, 2, new Font("Dialog", 1, 12), Color.black));
		orientationPanel.setLayout(new BoxLayout(orientationPanel, BoxLayout.Y_AXIS));
		orientationPanel.setLocation(new Point(9, 251));
		orientationPanel.setSize(new Dimension(184, 94));
		orientationPanel.setVisible(true);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		pitchLabel.setText("P: ");
		pitch.setText("0.0");
		
		p.add(pitchLabel);
		p.add(pitch);
		
		orientationPanel.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
		
		
		yawLabel.setText("Y: ");		
		yaw.setText("0.0");
		
		p.add(yawLabel);
		p.add(yaw);
		
		orientationPanel.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		rollLabel.setText("R: ");
		roll.setText("0.0");
		
		p.add(rollLabel);
		p.add(roll);
		
		orientationPanel.add(p);
		
		angularVelPanel.setBorder(new javax.swing.plaf.BorderUIResource.TitledBorderUIResource(new javax.swing.border.LineBorder(new Color(153, 153, 153), 1, false), "Angluar Velocity (r/s)", 4, 2, new Font("Dialog", 1, 12), Color.black));
		angularVelPanel.setLayout(new BoxLayout(angularVelPanel, BoxLayout.Y_AXIS));
		angularVelPanel.setLocation(new Point(9, 352));
		angularVelPanel.setSize(new Dimension(184, 94));
		angularVelPanel.setVisible(true);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		pitchVelLabel.setText("P: ");
		pitchVel.setText("0.0");
		
		p.add(pitchVelLabel);
		p.add(pitchVel);
		
		angularVelPanel.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));
		
		
		yawVelLabel.setText("Y: ");		
		yawVel.setText("0.0");
		
		p.add(yawVelLabel);
		p.add(yawVel);
		
		angularVelPanel.add(p);
		
		p = new JPanel();
		p.setLayout(new BoxLayout(p, BoxLayout.X_AXIS));

		rollVelLabel.setText("R: ");
		rollVel.setText("0.0");
		
		p.add(rollVelLabel);
		p.add(rollVel);
		
		angularVelPanel.add(p);
		
		
		name.setLocation(new Point(58, 14));
		name.setSize(new Dimension(133, 19));
		name.setText("Particle1");
		name.setVisible(true);
		elasticity.setLocation(new Point(144, 518));
		elasticity.setSize(new Dimension(50, 20));
		elasticity.setText("1.0");
		elasticity.setVisible(true);
		jLabel5.setLocation(new Point(16, 518));
		jLabel5.setSize(new Dimension(98, 20));
		jLabel5.setText("Elasticity (0 to 1)");
		jLabel5.setVisible(true);
		jLabel6.setLocation(new Point(13, 13));
		jLabel6.setSize(new Dimension(36, 20));
		jLabel6.setText("Name");
		jLabel6.setVisible(true);
		prevButton.setLocation(new Point(20, 602));
		prevButton.setSize(new Dimension(80, 20));
		prevButton.setText("<< Prev");
		prevButton.setToolTipText("Click to go to the Previous Object");
		prevButton.setVisible(true);
		nextButton.setLocation(new Point(100, 602));
		nextButton.setSize(new Dimension(80, 20));
		nextButton.setText("Next >>");
		nextButton.setToolTipText("Click to go to the next Particle");
		nextButton.setVisible(true);
		setIconImage(img0);
		getContentPane().setLayout(null);
		setLocation(new Point(800, 0));
		setResizable(false);
		setTitle("Properties");

	/*	jPanel1.add(jLabel2);
		jPanel1.add(xPosition);
		jPanel1.add(jLabel3);
		jPanel1.add(yPosition);
		jPanel1.add(jLabel4);
		jPanel1.add(zPosition);
		
*/

		getContentPane().add(jLabel1);
		getContentPane().add(mass);
		getContentPane().add(updateButton);
		getContentPane().add(resetButton);
		getContentPane().add(jLabel10);
		getContentPane().add(radius);
		getContentPane().add(jPanel1);
		getContentPane().add(jPanel2);
		getContentPane().add(orientationPanel);
		getContentPane().add(angularVelPanel);
		getContentPane().add(name);
		getContentPane().add(elasticity);
		getContentPane().add(jLabel5);
		getContentPane().add(jLabel6);
		getContentPane().add(prevButton);
		getContentPane().add(nextButton);

		setSize(new java.awt.Dimension(209, 650));

		// event handling
		updateButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				updateButtonActionPerformed(e);
			}
		});
		resetButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				reset();
			}
		});
		prevButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				prevButtonActionPerformed(e);
			}
		});
		nextButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent e) {
				nextButtonActionPerformed(e);
			}
		});

		if(mainFrame != null)
		{	
			Dimension d = getToolkit().getScreenSize();
			this.setLocation((int)d.getWidth() / 2 + mainFrame.getWidth() / 2, (int)d.getHeight() / 2 - getHeight() / 2);
			mainFrame.addComponentListener(new java.awt.event.ComponentAdapter() {
				public void componentMoved(java.awt.event.ComponentEvent e) {
					Dimension dm = getToolkit().getScreenSize();
					setLocation((int)mainFrame.getX() + mainFrame.getWidth(), (int)dm.getHeight() / 2 - getHeight() / 2);
				}
				public void componentResized(ComponentEvent e) {
					Dimension dm = getToolkit().getScreenSize();
					setLocation((int)mainFrame.getX() + mainFrame.getWidth(), (int)dm.getHeight() / 2 - getHeight() / 2);

				}
			});
		}
		if(currentObject == null)
		{
			name.setEnabled(false);
			mass.setEnabled(false);
			updateButton.setEnabled(false);
			resetButton.setEnabled(false);
			xPosition.setEnabled(false);
			yPosition.setEnabled(false);
			zPosition.setEnabled(false);
			xSpeed.setEnabled(false);
			ySpeed.setEnabled(false);
			zSpeed.setEnabled(false);
			radius.setEnabled(false);
			pitch.setEnabled(false);
			yaw.setEnabled(false);
			roll.setEnabled(false);
			pitchVel.setEnabled(false);
			yawVel.setEnabled(false);
			rollVel.setEnabled(false);
			elasticity.setEnabled(false);
			
		}

	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		JOptionPane.showMessageDialog(this, "To Quit Press the Close Button on the Main Window or use the File Menu", "Error!",  JOptionPane.ERROR_MESSAGE);
		
	}
	
	//Update the current object with the current values
	public void updateButtonActionPerformed(java.awt.event.ActionEvent e) {
		
		try
		{
			double xPos = Double.parseDouble(xPosition.getText());
			double yPos = Double.parseDouble(yPosition.getText());
			double zPos = Double.parseDouble(zPosition.getText());
			
			Vector3d newPosition = new Vector3d(xPos, yPos, zPos);
			
			double xSpd = Double.parseDouble(xSpeed.getText());
			double ySpd = Double.parseDouble(ySpeed.getText());
			double zSpd = Double.parseDouble(zSpeed.getText());
			
			Vector3d newSpeed = new Vector3d(xSpd, ySpd, zSpd);
			
			
			double p = Double.parseDouble(pitch.getText());
			double y = Double.parseDouble(yaw.getText());
			double r = Double.parseDouble(roll.getText());
									
			Quat4d orientation = Particle3D.makeQFromEulerAngles(p,y,r);
								
			double pv = Double.parseDouble(pitchVel.getText());
			double yv = Double.parseDouble(yawVel.getText());											
			double rv = Double.parseDouble(rollVel.getText());
			
			Vector3d angularV = new Vector3d(pv, yv, rv);
			
			double newMass = Double.parseDouble(mass.getText());
			
			double newRadius = Double.parseDouble(radius.getText());
			
			double newElasticity = Double.parseDouble(elasticity.getText());
			
			currentObject.setName(name.getText());
			currentObject.setMass(newMass);
			currentObject.setPosition(newPosition);
			currentObject.setSpeed(newSpeed);
			currentObject.setOrientation(orientation);
			currentObject.setAngularSpeed(angularV);
			currentObject.setRadius(newRadius);
			currentObject.setElasticity(newElasticity);
		
		}
		catch(Exception exp)
		{
			exp.printStackTrace();
			reset();
			JOptionPane.showMessageDialog(this, "Error You did not enter a number", "Error", JOptionPane.ERROR_MESSAGE);
		}
		
		Particle3DTracker.updateAll();
	
	}
	
			
	//Set the selected object		
	public void setObject(Particle3D newObject)
	{
		currentObject = newObject;
		System.out.println("Got New Object");
		if(newObject == null)
			System.out.println("Object Cleared");
		reset();
	}
	
	//Resets the text fields to the current values of the object
	public void reset()
	{
		if(currentObject == null)
		{
			name.setEnabled(false);
			mass.setEnabled(false);
			updateButton.setEnabled(false);
			resetButton.setEnabled(false);
			xPosition.setEnabled(false);
			yPosition.setEnabled(false);
			zPosition.setEnabled(false);
			xSpeed.setEnabled(false);
			ySpeed.setEnabled(false);
			zSpeed.setEnabled(false);
			pitch.setEnabled(false);
			yaw.setEnabled(false);
			roll.setEnabled(false);
			pitchVel.setEnabled(false);
			yawVel.setEnabled(false);
			rollVel.setEnabled(false);
			radius.setEnabled(false);
			elasticity.setEnabled(false);
			
		}
		else
		{
			name.setText(currentObject.getName());
			
			mass.setText(Double.toString(currentObject.getMass()));
			
			Vector3d position = currentObject.getPosition();
			
			xPosition.setText(Double.toString(position.x));
			yPosition.setText(Double.toString(position.y));
			zPosition.setText(Double.toString(position.z));
			
			Vector3d speed = currentObject.getSpeed();
			
			xSpeed.setText(Double.toString(speed.x));
			ySpeed.setText(Double.toString(speed.y));
			zSpeed.setText(Double.toString(speed.z));
			
			
			Vector3d orientation = Particle3D.makeEulerAnglesFromQ(currentObject.getOrientation());
			Vector3d angularSpeed = currentObject.getAngularSpeed();
			
			pitch.setText(Double.toString(orientation.x));
			yaw.setText(Double.toString(orientation.y));
			roll.setText(Double.toString(orientation.z));
			
			pitchVel.setText(Double.toString(angularSpeed.x));
			yawVel.setText(Double.toString(angularSpeed.y));
			rollVel.setText(Double.toString(angularSpeed.z));
			
			radius.setText(Double.toString(currentObject.getRadius()));
			elasticity.setText(Double.toString(currentObject.getElasticity()));
			
			name.setEnabled(true);
			mass.setEnabled(true);
			updateButton.setEnabled(true);
			resetButton.setEnabled(true);
			xPosition.setEnabled(true);
			yPosition.setEnabled(true);
			zPosition.setEnabled(true);
			xSpeed.setEnabled(true);
			ySpeed.setEnabled(true);
			zSpeed.setEnabled(true);
			pitch.setEnabled(true);
			yaw.setEnabled(true);
			roll.setEnabled(true);
			pitchVel.setEnabled(true);
			yawVel.setEnabled(true);
			rollVel.setEnabled(true);
			radius.setEnabled(true);
			elasticity.setEnabled(true);
			
		}
	}
	
	//Get the next / previous objects
	public void nextButtonActionPerformed(java.awt.event.ActionEvent e) {
		if(currentObject == null)
		{
			currentObject = (Particle3D)Particle3D.getParticles()[0];
			
		}
		else
		{
			currentObject.setAppearance(Physics3DThread.getNormalAppearance());
			currentObject = Particle3D.getNextParticle(currentObject);
		}
		currentObject.setAppearance(Physics3DThread.getSelectedAppearance());
		mainFrame.t.setLastShape(currentObject.getShape3D());
		reset();
	}	
	
	public void prevButtonActionPerformed(java.awt.event.ActionEvent e) {
		if(currentObject == null)
		{
			currentObject = (Particle3D)Particle3D.getParticles()[0];
			
		}
		else
		{
			currentObject.setAppearance(Physics3DThread.getNormalAppearance());
			currentObject = Particle3D.getPrevParticle(currentObject);
		}
		currentObject.setAppearance(Physics3DThread.getSelectedAppearance());
		mainFrame.t.setLastShape(currentObject.getShape3D());
		reset();
	}
	
	
	public void windowStateChanged(WindowEvent e)
	{
		if(mainFrame != null)
		{	
			Dimension d = getToolkit().getScreenSize();
			this.setLocation((int)d.getWidth() / 2 + mainFrame.getWidth() / 2, (int)d.getHeight() / 2 - getHeight() / 2);
		}	
	}
	
}