/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.text.*;

public class TimeParticle3DTracker extends Particle3DTracker
{
	private static DecimalFormat timeFormatter = new DecimalFormat("00");
	JLabel currentTime;
	
	public TimeParticle3DTracker()
	{
		super();
		particles = null;
		
	 	this.setTitle("Current Simulation Time");
	 	Date d = new Date(Particle3D.getTime());

	 	currentTime = new JLabel("Time: " +	timeFormatter.format((d.getHours() - 19)) + ":" + 
	 					timeFormatter.format(d.getMinutes()) + ":" + 
	 					timeFormatter.format(d.getSeconds()));
	 					
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1,1));
	 	cp.add(currentTime);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		Date d = new Date(Particle3D.getTime());
	 	currentTime.setText("Time: " + timeFormatter.format((d.getHours() - 19)) + ":" + 
	 					timeFormatter.format(d.getMinutes()) + ":" + 
	 					timeFormatter.format(d.getSeconds()));
	}
	
	public String toString()
	{
		Date d = new Date(Particle3D.getTime());
	 	return "Time: " + timeFormatter.format((d.getHours() - 19)) + ":" + 
	 					timeFormatter.format(d.getMinutes()) + ":" + 
	 					timeFormatter.format(d.getSeconds());

	}

}