/***************************************************

Copyright 2003 Ben Childs


This file is part of Physics 3D.

    Physics 3D is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Physics 3D is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Physics 3D; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA




***************************************************/

package com.bchilds.Physics3D;


import javax.vecmath.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class VelocityParticle3DTracker extends Particle3DTracker
{
	
	JLabel xVel, yVel, zVel, mVel;
	
	public VelocityParticle3DTracker(Particle3D p)
	{
		super();
		particles = new Particle3D[1];
		particles[0] = p;
	 	this.setTitle("Vel: " + p.getName());
	 	
	 	xVel = new JLabel("X: " + p.getSpeed().x);
	 	yVel = new JLabel("Y: " + p.getSpeed().y);
	 	zVel = new JLabel("Z: " + p.getSpeed().z);
	 	mVel = new JLabel("Avg: " + p.getSpeed().length());
	 	Container cp = this.getContentPane();
	 		 	
	 	cp.setLayout(new GridLayout(1, 4));
	 	cp.add(xVel);
	 	cp.add(yVel);
	 	cp.add(zVel);
	 	cp.add(mVel);
	 	
	 	setVisible(true);	 	
	}

	public void updateInfo()
	{
		this.setTitle("Vel: " + particles[0].getName());
		xVel.setText("X: " + particles[0].getSpeed().x);
	 	yVel.setText("Y: " + particles[0].getSpeed().y);
	 	zVel.setText("Z: " + particles[0].getSpeed().z);
	 	mVel.setText("Avg: " +  particles[0].getSpeed().length());
	}
	
	public String toString()
	{
		return "Vel: " + particles[0].getName() + " : "
				+ "X: " + particles[0].getSpeed().x + " : "
	 			+ "Y: " + particles[0].getSpeed().y + " : "
	 			+ "Z: " + particles[0].getSpeed().z;
	}

}