;NSIS Modern User Interface version 1.62
;Welcome/Finish Page Example Script
;Written by Joost Verburg

!define MUI_PRODUCT "Physics 3D" ;Define your own software name here
!define MUI_VERSION "1.0.4" ;Define your own software version here

!include "MUI.nsh"

;Remember the Start Menu Folder
!define MUI_STARTMENU_REGISTRY_ROOT "HKCU" 
!define MUI_STARTMENU_REGISTRY_KEY "Software\${MUI_PRODUCT}" 
!define MUI_STARTMENU_REGISTRY_VALUENAME "Start Menu Folder"
!define MUI_SPECIALBITMAP "setup.bmp"
!define DOCS_LOCATION "C:\Documents and Settings\Ben Childs.BC1700\My Documents\Physics3D"

!define TEMP $R0

;--------------------------------
;Configuration

  ;General
  OutFile "Physics3DSetupBasic.exe"

  ;Folder selection page
  InstallDir "$PROGRAMFILES\${MUI_PRODUCT}"

 

;--------------------------------
;Modern UI Configuration

  !define MUI_WELCOMEPAGE
  !define MUI_LICENSEPAGE
  !define MUI_COMPONENTSPAGE
  !define MUI_DIRECTORYPAGE
  !define MUI_STARTMENUPAGE
  !define MUI_FINISHPAGE
   
  
  !define MUI_ABORTWARNING
  
  !define MUI_UNINSTALLER
  !define MUI_UNCONFIRMPAGE
  
  ;Modern UI System
  !insertmacro MUI_SYSTEM
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"
  
;--------------------------------
;Language Strings

  ;Description
  LangString DESC_SecCopyUI ${LANG_ENGLISH} "Copy the Physics 3d files to the application folder."
  LangString DESC_SecCopyUI3 ${LANG_ENGLISH} "Copy the Source files to the application folder."
;  LangString DESC_SecCopyUI1 ${LANG_ENGLISH} "Install the Java Runtime (required if not already installed)"
;  LangString DESC_SecCopyUI2 ${LANG_ENGLISH} "Install the Java3D Runtime (required if not already installed)"

;--------------------------------
;Data
  
  LicenseData "License.txt"
  
;--------------------------------
;Reserve Files

  ;Things that need to be extracted on first (keep these lines before any File command!)
  ;Only useful for BZIP2 compression
  !insertmacro MUI_RESERVEFILE_WELCOMEFINISHPAGE

;--------------------------------
;Installer Sections

Section "Physics3D" SecCopyUI

  ;Add your stuff here

  SetOutPath "$INSTDIR"
  File "Physics3D.jar"
  File "Physics3D.ico"
  File "back.png"
  File "License.txt"
  File "Readme.txt"
  File /r "Examples"
  File "${DOCS_LOCATION}\Physics3D.pdf"

   !insertmacro MUI_STARTMENU_WRITE_BEGIN
    
    ;Create shortcuts
    CreateDirectory "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}"
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}\Physics3D.lnk" "$SYSDIR\javaw.exe" "-cp .\;Physics3D.jar com.bchilds.Physics3D.Physics3D" "$INSTDIR\Physics3D.ico"
    CreateShortCut "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
    CreateShortcut "$SMPROGRAMS\${MUI_STARTMENU_VARIABLE}\Manual PDF.lnk" "$INSTDIR\Physics3D.pdf" "" "$INSTDIR\Physics3D.ico"
    ;Write shortcut location to the registry (for Uninstaller)
    WriteRegStr HKCU "Software\${MUI_PRODUCT}" "Start Menu Folder" "${MUI_STARTMENU_VARIABLE}"
    
  !insertmacro MUI_STARTMENU_WRITE_END

  ;Create uninstaller
  WriteUninstaller "$INSTDIR\Uninstall.exe"

SectionEnd

Section "Source Code" SecCopyUI3

  ;Add your stuff here

  SetOutPath "$INSTDIR"
  File /r "Physics3D"
  File "License.txt"

SectionEnd



;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTIONS_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI} $(DESC_SecCopyUI)
; !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI1} $(DESC_SecCopyUI1)
;  !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI2} $(DESC_SecCopyUI2)
   !insertmacro MUI_DESCRIPTION_TEXT ${SecCopyUI3} $(DESC_SecCopyUI3)
!insertmacro MUI_FUNCTIONS_DESCRIPTION_END

;--------------------------------
;Uninstaller Section

Section "Uninstall"

  ;Add your stuff here

  Delete "$INSTDIR\Physics3D.jar"
  Delete "$INSTDIR\Physics3D.ico"
  Delete "$INSTDIR\back.png"
  Delete "$INSTDIR\Uninstall.exe"

  
  ;Remove shortcut
  ReadRegStr ${TEMP} HKCU "Software\${MUI_PRODUCT}" "Start Menu Folder"
  
  StrCmp ${TEMP} "" noshortcuts
  
    Delete "$SMPROGRAMS\${TEMP}\Physics3D.lnk"
    Delete "$SMPROGRAMS\${TEMP}\Uninstall.lnk"
    RMDir "$SMPROGRAMS\${TEMP}" ;Only if empty, so it won't delete other shortcuts
    
  noshortcuts:

  RMDir /r "$INSTDIR"

  DeleteRegValue HKCU "Software\${MUI_PRODUCT}" "Start Menu Folder"

  !insertmacro MUI_UNFINISHHEADER

SectionEnd